Difference between revisions of "VMware"

From ArchWiki
Jump to: navigation, search
(Installation)
(update interlanguage links)
(Tag: wiki-scripts)
 
(288 intermediate revisions by 74 users not shown)
Line 1: Line 1:
[[Category:Virtualization]]
+
[[Category:Hypervisors]]
 
[[it:VMware]]
 
[[it:VMware]]
 +
[[ja:VMware]]
 
[[ru:VMware]]
 
[[ru:VMware]]
[[uk:VMware]]
+
[[zh-hans:VMware]]
[[zh-CN:VMware]]
+
{{Related articles start}}
{{Article summary start}}
+
{{Related|:Category:Hypervisors}}
{{Article summary text|This article will explain how to install and configure VMware Workstation/Player (Plus) in Arch.}}
+
{{Related|VMware/Installing Arch as a guest}}
{{Article summary heading|Related}}
+
{{Related|Moving an existing install into (or out of) a virtual machine}}
{{Article summary wiki|Installing Arch Linux in VMware}}
+
{{Related articles end}}
{{Article summary wiki|VirtualBox}}
 
{{Article summary wiki|KVM}}
 
{{Article summary wiki|QEMU}}
 
{{Article summary wiki|Xen}}
 
{{Article summary wiki|Moving an existing install into (or out of) a virtual machine}}
 
{{Article summary end}}
 
  
This article is about installing VMware in Arch Linux; you may also be interested in [[Installing Arch Linux in VMware]].
+
This article is about installing VMware in Arch Linux; you may also be interested in [[VMware/Installing Arch as a guest]].
{{Note|This article supports '''only''' the latest major VMware versions, meaning VMware Workstation 10 and VMware Player (Plus) 6.}}
+
{{Note|
 +
*This article is about the latest major VMware versions, meaning VMware Workstation Pro and Player 12.5.
 +
*For older versions, use the {{AUR|vmware-patch}} package.
 +
}}
  
 
== Installation ==
 
== Installation ==
  
{{Note|VMware Workstation/Player (Plus) will '''not''' be manageable with pacman as the files are not installed with it.}}
+
[[Install]] the correct dependencies:
 +
*{{pkg|fuse2}} - for ''vmware-vmblock-fuse''
 +
*{{pkg|gksu}} - for root operations (memory allocations, registering license, etc.)
 +
*{{pkg|gtkmm}} - for the GUI
 +
*{{pkg|linux-headers}} - for module compilation
 +
*{{AUR|ncurses5-compat-libs}} - needed by the {{ic|--console}} installer
 +
*{{pkg|libcanberra}} - for event sounds
  
'''1.''' Download the latest [http://www.vmware.com/products/workstation VMware Workstation] or [https://my.vmware.com/web/vmware/free#desktop_end_user_computing/vmware_player/6_0 VMware Player (Plus)] (you may also try the [https://communities.vmware.com/community/vmtn/beta testing (Beta/RC) versions]).
+
Download the latest [https://www.vmware.com/go/tryworkstation VMware Workstation Pro] or [https://www.vmware.com/go/downloadplayer Player] (or a [https://communities.vmware.com/community/vmtn/beta beta] version, if available).
  
'''2.''' Start the installation ({{Ic|--console}} uses terminal instead of the GUI):
+
Start the installation:
$ chmod +x VMware-''edition''-''version''.''release''.''architecture''.bundle
+
  # sh VMware-''edition''-''version''.''release''.''architecture''.bundle
  # ./VMware-''edition''-''version''.''release''.''architecture''.bundle --console
 
  
{{Note|To ignore fatal errors use {{ic|--ignore-errors}} or {{ic|-I}}.}}
+
{{Tip|Some useful flags:
 +
*{{ic|--eulas-agreed}} - Skip the EULAs
 +
*{{ic|--console}} - Use the console UI.
 +
*{{ic|--custom}} - Allows changing the install directory to e.g. {{ic|/usr/local}} (make sure to update the {{ic|vmware-usbarbitrator.service}} paths in [[#systemd services]]).
 +
*{{ic|-I}}, {{ic|--ignore-errors}} - Ignore fatal errors.
 +
*{{ic|1=--set-setting=vmware-workstation serialNumber XXXXX-XXXXX-XXXXX-XXXXX-XXXXX}} - Set the serial number during install (good for scripted installs).
 +
*{{ic|--required}} - Only ask mandatory questions (results in silent install when combined with {{ic|--eulas-agreed}} and {{ic|--console}}).
 +
}}
  
'''3.''' Read and accept the main application and the [https://www.vmware.com/support/developer/ovf/ OVF Tool component] EULAs to continue.
+
For the {{ic|System service scripts directory}}, use {{ic|/etc/init.d}} (the default).
  
'''4.''' (optional) Enter license key.
+
{{Note|During the installation you will get an error about {{ic|"No rc*.d style init script directories"}} being given. This can be safely ignored, since Arch uses [[systemd]].}}
  
'''5.''' During the install you will now get an error about {{ic|"No rc*.d style init script directories"}} being given to the installer. This can, however, be safely ignored since Arch now uses [[systemd]].
+
{{Tip|To (re)build the modules from terminal later on, use:
 +
# vmware-modconfig --console --install-all
 +
}}
  
 
== Configuration ==
 
== Configuration ==
  
{{Tip|There is also a package called {{AUR|vmware-patch}} in the [[Arch User Repository|AUR]] with the intention of trying to automate this section (it also supports older VMware versions).}}
+
=== Kernel modules ===
  
{{Note|Ensure you have installed the correct headers required for building the modules ({{Pkg|linux}} from {{ic|[core]}} uses {{Pkg|linux-headers}}).}}
+
VMware Workstation 12.5 supports kernels up to 4.8 out of the box.
  
=== VMware module patches and installation ===
+
=== systemd services ===
  
VMware Workstation 10 and Player (Plus) 6 support kernels up to 3.11.
+
''(Optional)'' Instead of using {{ic|/etc/init.d/vmware}} ({{ic|<nowiki>start|stop|status|restart</nowiki>}}) and {{ic|/usr/bin/vmware-usbarbitrator}} directly to manage the services, you may also use {{ic|.service}} files (also available in the {{AUR|vmware-systemd-services}} package, and also included in {{AUR|vmware-patch}}):
 
 
=== Systemd service ===
 
 
 
'''6.''' (Optional) Instead of using {{ic|<nowiki># /etc/init.d/vmware {start|stop|status|restart}</nowiki>}} directly to manage the services you may also create a {{ic|.service}} file (or [http://communities.vmware.com/docs/DOC-20855 files]):
 
  
 
{{hc|/etc/systemd/system/vmware.service|
 
{{hc|/etc/systemd/system/vmware.service|
 
2=[Unit]
 
2=[Unit]
 
Description=VMware daemon
 
Description=VMware daemon
 +
Requires=vmware-usbarbitrator.service
 +
Before=vmware-usbarbitrator.service
 +
After=network.target
  
 
[Service]
 
[Service]
Line 58: Line 69:
 
ExecStop=/etc/init.d/vmware stop
 
ExecStop=/etc/init.d/vmware stop
 
PIDFile=/var/lock/subsys/vmware
 
PIDFile=/var/lock/subsys/vmware
TimeoutSec=0
 
 
RemainAfterExit=yes
 
RemainAfterExit=yes
  
Line 65: Line 75:
 
}}
 
}}
  
To start the [[daemon]] on boot, enable the [[systemd]] service {{ic|vmware}}.
+
{{hc|/etc/systemd/system/vmware-usbarbitrator.service|
 +
2=[Unit]
 +
Description=VMware USB Arbitrator
 +
Requires=vmware.service
 +
After=vmware.service
 +
 
 +
[Service]
 +
ExecStart=/usr/bin/vmware-usbarbitrator
 +
ExecStop=/usr/bin/vmware-usbarbitrator --kill
 +
RemainAfterExit=yes
 +
 
 +
[Install]
 +
WantedBy=multi-user.target
 +
}}
 +
 
 +
Add this service as well, if you want to connect to your VMware Workstation installation from another Workstation Server Console:
 +
 
 +
{{hc|/etc/systemd/system/vmware-workstation-server.service|
 +
2=[Unit]
 +
Description=VMware Workstation Server
 +
Requires=vmware.service
 +
After=vmware.service
 +
 
 +
[Service]
 +
ExecStart=/etc/init.d/vmware-workstation-server start
 +
ExecStop=/etc/init.d/vmware-workstation-server stop
 +
PIDFile=/var/lock/subsys/vmware-workstation-server
 +
RemainAfterExit=yes
 +
 
 +
[Install]
 +
WantedBy=multi-user.target
 +
}}
 +
 
 +
After which you can [[enable]] them on boot.
 +
 
 +
==== Workstation Server service ====
 +
 
 +
The {{ic|vmware-workstation-server.service}} calls {{ic|wssc-adminTool}} in its command chain, despite having been renamed to {{ic|vmware-wssc-adminTool}}.
 +
 
 +
To prevent the service startup, this can be fixed with a symlink:
 +
 
 +
# ln -s wssc-adminTool /usr/lib/vmware/bin/vmware-wssc-adminTool
  
 
== Launching the application ==
 
== Launching the application ==
  
'''7.''' Now, open your VMware Workstation ({{Ic|vmware}} in the console) or VMware Player (Plus) ({{Ic|vmplayer}} in the console) to configure & use!
+
To open VMware Workstation Pro:
 +
$ vmware
  
{{Tip|To (re)build the modules from terminal, use:
+
or Player:
  # vmware-modconfig --console --install-all
+
  $ vmplayer
}}
 
  
 
== Tips and tricks ==
 
== Tips and tricks ==
  
=== Entering the Workstation License Key ===
+
=== Entering the Workstation Pro license key ===
  
 
==== From terminal ====
 
==== From terminal ====
Line 89: Line 140:
 
==== From GUI ====
 
==== From GUI ====
  
If the above doesn't work, you can try:
+
If the above does not work, you can try:
  
 
  # /usr/lib/vmware/bin/vmware-enter-serial
 
  # /usr/lib/vmware/bin/vmware-enter-serial
Line 97: Line 148:
 
  $ objcopy /usr/lib/vmware/bin/vmware-vmx -O binary -j bios440 --set-section-flags bios440=a bios440.rom.Z
 
  $ objcopy /usr/lib/vmware/bin/vmware-vmx -O binary -j bios440 --set-section-flags bios440=a bios440.rom.Z
 
  $ perl -e 'use Compress::Zlib; my $v; read STDIN, $v, '$(stat -c%s "./bios440.rom.Z")'; $v = uncompress($v); print $v;' < bios440.rom.Z > bios440.rom
 
  $ perl -e 'use Compress::Zlib; my $v; read STDIN, $v, '$(stat -c%s "./bios440.rom.Z")'; $v = uncompress($v); print $v;' < bios440.rom.Z > bios440.rom
 +
 +
=== Extracting the installer ===
 +
 +
To view the contents of the installer {{ic|.bundle}}:
 +
 +
$ sh VMware-''edition''-''version''.''release''.''architecture''.bundle --extract ''/tmp/vmware-bundle/''
  
 
==== Using the modified BIOS ====
 
==== Using the modified BIOS ====
  
If and when you decide to modify the extracted BIOS you can make your virtual machine use it by moving it to {{ic|~/vmware/''Virtual machine name''}}:
+
If and when you decide to modify the extracted BIOS you can make your virtual machine use it by moving it to {{ic|~/vmware/''Virtual_machine_name''}}:
  $ mv bios440.rom ~/vmware/''Virtual machine name''/
+
  $ mv bios440.rom ~/vmware/''Virtual_machine_name''/
  
then adding the name to the {{ic|''Virtual machine name''.vmx}} file:
+
then adding the name to the {{ic|''Virtual_machine_name''.vmx}} file:
{{hc|~/vmware/''Virtual machine name''/''Virtual machine name''.vmx|2=bios440.filename = "bios440.rom"}}
+
{{hc|~/vmware/''Virtual_machine_name''/''Virtual_machine_name''.vmx|2=bios440.filename = "bios440.rom"}}
  
=== Copy-On-Write (CoW) ===
+
=== Enable 3D graphics on Intel and Optimus ===
  
CoW comes with some advantages, but can negatively affect performance with large files that have small random writes (e.g. database files and virtual machine images):
+
Some graphics drivers are blacklisted by default, due to poor and/or unstable 3D acceleration. After enabling ''Accelerate 3D graphics'', the log may show something like:
  
  $ chattr +C ~/vmware/''Virtual machine name''/''Virtual machine name''.vmx
+
  Disabling 3D on this host due to presence of Mesa DRI driver.  Set mks.gl.allowBlacklistedDrivers = TRUE to override.
  
{{Note|1=From the [http://www.linuxhowtos.org/manpages/1/chattr.htm?print=-51 chattr man page]: ''"For btrfs, the {{ic|C}} flag should be set only on new or empty files. If set on a file which already has data blocks, it is undefined when the blocks assigned to the file will be fully stable. If set on a directory, only new files will be affected."''}}
+
This means the following:
  
=== Using DKMS to manage the modules ===
+
{{hc|~/.vmware/preferences|2=
 +
mks.gl.allowBlacklistedDrivers = TRUE
 +
}}
  
The Dynamic Kernel Module Support (DKMS) can be used to manage Workstation modules and to void from re-running {{ic|vmware-modconfig}} each time the kernel changes. The following example uses a custom {{ic|Makefile}} to compile and install the modules through {{ic|vmware-modconfig}}. Afterwards they are removed from the current kernel tree.
+
== Troubleshooting ==
  
==== Preparation ====
+
=== Kernel headers for version 4.x-xxxx were not found. If you installed them[...] ===
  
First install {{Pkg|dkms}} from the [[official repositories]].
+
Install the headers ({{Pkg|linux-headers}}).
  
Then create a source directory for the {{ic|Makefile}} and the {{ic|dkms.conf}}:
+
{{Note|Upgrading the kernel and the headers will require you to boot to the new kernel to match the version of the headers. This is a relatively common error.}}
# mkdir /usr/src/vmware-modules-9/
 
  
==== Build configuration ====
+
=== USB devices not recognized ===
  
Fetch the files from Git or use the ones below.
+
{{Tip|Also handled by {{AUR|vmware-patch}}.}}
  
===== 1) Using Git =====
+
If not using the [[#systemd services|systemd service]] to automatically handle the services, you need to manually start the {{ic|vmware-usbarbitrator}} binary as root each time.
  
$ cd /tmp
+
To start:
$ git clone git://github.com/djod4556/dkms-workstation.git
 
# cp /tmp/dkms-workstation.git/Makefile /tmp/dkms-workstation.git/dkms.conf /usr/src/vmware-modules-9/
 
  
===== 2) Manual setup =====
+
# vmware-usbarbitrator
  
The {{ic|dkms.conf}} describes the module names and the compilation/installation procedure. {{ic|1=AUTOINSTALL="yes"}} tells the modules to be recompiled/installed automatically each time:
+
To stop:
  
{{hc|/usr/src/vmware-modules-9/dkms.conf|
+
# vmware-usbarbitrator --kill
2=PACKAGE_NAME="vmware-modules"
 
PACKAGE_VERSION="9"
 
  
MAKE[0]="make all"
+
=== Incorrect login/password when trying to access VMware remotely ===
CLEAN="make clean"
 
  
BUILT_MODULE_NAME[0]="vmmon"
+
VMware Workstation provides the possibility to remotely manage Shared VMs through the {{ic|vmware-workstation-server}} service. However, this will fail with the error {{ic|"incorrect username/password"}} due to incorrect [[PAM]] configuration of the {{ic|vmware-authd}} service. To fix it, edit {{ic|/etc/pam.d/vmware-authd}} like this:
BUILT_MODULE_LOCATION[0]="modules"
 
  
BUILT_MODULE_NAME[1]="vmnet"
+
{{hc|/etc/pam.d/vmware-authd|
BUILT_MODULE_LOCATION[1]="modules"
+
#%PAM-1.0
 +
auth    ''required      pam_unix.so''
 +
account  ''required      pam_unix.so''
 +
password ''required      pam_permit.so''
 +
session  ''required      pam_unix.so''
 +
}}
  
BUILT_MODULE_NAME[2]="vmblock"
+
and restart the {{ic|vmware}} [[systemd]] service.
BUILT_MODULE_LOCATION[2]="modules"
 
  
BUILT_MODULE_NAME[3]="vmci"
+
Now you can connect to the server with the credentials provided during the installation.
BUILT_MODULE_LOCATION[3]="modules"
 
  
BUILT_MODULE_NAME[4]="vsock"
+
{{Note|{{Pkg|libxslt}} may be required for starting virtual machines.}}
BUILT_MODULE_LOCATION[4]="modules"
 
  
DEST_MODULE_LOCATION[0]="/extra/vmware"
+
=== Issues with ALSA output ===
DEST_MODULE_LOCATION[1]="/extra/vmware"
+
 
DEST_MODULE_LOCATION[2]="/extra/vmware"
+
[http://bankimbhavsar.blogspot.co.nz/2011/09/hd-audio-in-vmware-fusion-4-and-vmware.html To fix] sound quality issues or enabling proper HD audio output, first run:
DEST_MODULE_LOCATION[3]="/extra/vmware"
+
$ aplay -L
DEST_MODULE_LOCATION[4]="/extra/vmware"
+
 
 +
If interested in playing 5.1 ''surround sound'' from the guest, look for {{ic|1=surround51:CARD=''vendor_name'',DEV=''num''}}, if experiencing quality issues, look for {{ic|1=front:CARD=''vendor_name'',DEV=''num''}}. Finally put the name in the {{ic|.vmx}}:
  
AUTOINSTALL="yes"
+
{{hc|~/vmware/''Virtual_machine_name''/''Virtual_machine_name''.vmx|2=
 +
sound.fileName=''"surround51:CARD=Live,DEV=0"''
 +
sound.autodetect=''"FALSE"''
 
}}
 
}}
  
and now the {{ic|Makefile}}:
+
[[Advanced_Linux_Sound_Architecture#OSS_compatibility|OSS emulation]] should also be disabled.
 +
 
 +
=== Kernel-based Virtual Machine (KVM) is running ===
 +
 
 +
To disable {{ic|KVM}} on boot, you can use something like:
 +
       
 +
{{hc|/etc/modprobe.d/vmware.conf|
 +
blacklist kvm
 +
blacklist kvm-amd  # For AMD CPUs
 +
blacklist kvm-intel # For Intel CPUs
 +
}}
  
{{hc|/usr/src/vmware-modules-9/Makefile|
+
=== Module Issues ===
2=KERNEL := $(KERNELRELEASE)
 
HEADERS := /usr/src/linux-$(KERNEL)/include
 
GCC := $(shell vmware-modconfig --console --get-gcc)
 
DEST := /lib/modules/$(KERNEL)/vmware
 
  
TARGETS := vmmon vmnet vmblock vmci vsock
+
==== /dev/vmmon not found ====
  
LOCAL_MODULES := $(addsuffix .ko, $(TARGETS))
+
The full error is:
  
all: $(LOCAL_MODULES)
+
Could not open /dev/vmmon: No such file or directory.
        mkdir -p modules/
+
Please make sure that the kernel module 'vmmon' is loaded.
        mv *.ko modules/
 
        rm -rf $(DEST)
 
        depmod
 
  
/usr/src/linux-$(KERNEL)/include/linux/version.h:
+
This means that at least the {{ic|vmmon}} module is not loaded. See the [[#systemd services]] section for automatic loading.
        ln -s /usr/src/linux-$(KERNEL)/include/generated/uapi/linux/version.h /usr/src/linux-$(KERNEL)/include/linux/
 
  
%.ko: /usr/src/linux-$(KERNEL)/include/linux/version.h
+
==== /dev/vmci not found ====
        vmware-modconfig --console --build-mod -k $(KERNEL) $* $(GCC) $(HEADERS) vmware/
 
        cp -f $(DEST)/$*.ko .
 
  
clean:
+
The full error is:
        rm -rf modules/
+
 
}}
+
Failed to open device "/dev/vmci": No such file or directory
 +
Please make sure that the kernel module 'vmci' is loaded.
 +
 
 +
Try to recompile VMware kernel modules with:
 +
 
 +
# vmware-modconfig --console --install-all
 +
 
 +
==== Kernel modules fail to build after Linux 4.9 ====
 +
 
 +
On VMware Workstation Pro 12.5.2, the module source needs to be modified to be successfully compiled under kernel 4.9 [http://rglinuxtech.com/?p=1847].
 +
 
 +
# cd /usr/lib/vmware/modules/source
 +
# tar xf vmmon.tar
 +
# mv vmmon.tar vmmon.old.tar
 +
# sed -i 's/uvAddr, numPages, 0, 0/uvAddr, numPages, 0/g' vmmon-only/linux/hostif.c
 +
# tar cf vmmon.tar vmmon-only
 +
# rm -r vmmon-only
 +
 
 +
# tar xf vmnet.tar
 +
# mv vmnet.tar vmnet.old.tar
 +
# sed -i 's/addr, 1, 1, 0/addr, 1, 0/g' vmnet-only/userif.c
 +
# tar cf vmnet.tar vmnet-only
 +
# rm -r vmnet-only
 +
 
 +
==== vmware modules fail to build on kernel 4.11+ and GCC 7 ====
 +
 
 +
Running vmware-modconfig yields:
 +
Failed to get gcc information.
 +
 
 +
The actual error can be found in the logs:
 +
modconfig| I125: Got gcc version "6.3.1".
 +
modconfig| I125: GCC major version 6 does not match Kernel GCC major version 7.
 +
modconfig| I125: The GCC compiler "/sbin/gcc" cannot be used for the target kernel.
 +
 
 +
To skip the check, use this workaround:
 +
# sed 's/gcc version 6/gcc version 7/' /proc/version > /tmp/version
 +
# mount --bind /tmp/version /proc/version
 +
# vmware-modconfig --console --install-all
 +
# umount /proc/version && rm /tmp/version
 +
 
 +
==== Kernel modules fail to build on Linux 4.13 ====
 +
 
 +
On VMware Workstation Pro 12.5.7, the module source needs to be modified to be successfully compiled under kernel 4.13 [https://communities.vmware.com/thread/568089].
 +
 
 +
# cd /usr/lib/vmware/modules/source
 +
# tar xf vmnet.tar
 +
# mv vmnet.tar vmnet.old.tar
 +
# sed -i 's/atomic_inc(&clone->users);/clone = skb_get(clone);/g' vmnet-only/bridge.c
 +
# tar cf vmnet.tar vmnet-only
 +
# rm -r vmnet-only
 +
 
 +
==== Failed to lock page for guest RAM on Linux 4.13 ====
 +
 
 +
VMware Workstation Pro versions from 12.5 up to 14.0 can lock up both guest and host systems while running a virtual machine under kernel 4.13 without a patch to the {{ic|vmmon}} module due to the virtual machine being unable to reserve memory on the host machine. The VM-specific log files show the following errors:
 +
 
 +
I125: [msg.monitorInit.mem.lockFailed] The virtual machine is unable to reserve memory.
 +
...
 +
E105: PANIC: Failed to lock page for guest RAM!
 +
 
 +
A collection of patches needed for the VMware host modules to build against recent kernels can be found from the following GitHub repository, [https://github.com/mkubecek/vmware-host-modules/tree/b50848c985f1a6c0a341187346d77f0119d0a835 vmware-host-modules].
 +
 
 +
=== Installer Fails to Start ===
 +
 
 +
If you just get back to the prompt when opening the {{ic|.bundle}}, then you probably have a deprecated or broken version of the VMware installer and it should removed (you may also refer to the [[#Uninstallation|uninstallation]] section of this article):
 +
# rm -r /etc/vmware-installer/
 +
 
 +
==== User interface initialization failed ====
 +
 
 +
You may also see an error like this:
 +
 
 +
  Extracting VMware Installer...done.
 +
  No protocol specified
 +
  No protocol specified
 +
  User interface initialization failed.  Exiting.  Check the log for details.
 +
 
 +
This can be fixed by either installing the {{AUR|ncurses5-compat-libs}} dependency or temporarily allowing root access to X:
 +
 
 +
  $ xhost +
 +
  $ sudo ./<vmware filename>.bundle
 +
  $ xhost -
 +
 
 +
=== VMware Fails to Start ===
 +
 
 +
==== Segmentation fault at startup due to old Intel microcode ====
 +
 
 +
Old Intel microcode may result in the following kind of segmentation fault at startup:
 +
 
 +
/usr/bin/vmware: line 31: 4941 Segmentation fault "$BINDIR"/vmware-modconfig --appname="VMware Workstation" --icon="vmware-workstation"
 +
 
 +
See [[Microcode]] for how to update the microcode.
 +
 
 +
==== vmplayer/vmware fails to start from version 12.5.4 ====
 +
 
 +
As per [https://bbs.archlinux.org/viewtopic.php?id=224667] the temporary workaround is to downgrade the package {{ic|libpng}} to version 1.6.28-1 and keep it in the {{ic|IgnorePkg}} parameter in [[Pacman#Skip_package_from_being_upgraded|/etc/pacman.conf]].
 +
 
 +
An easier workaround is to make VMWare use the system's version of zlib instead of its own one:
  
==== Installation ====
+
# cd /usr/lib/vmware/lib/libz.so.1
 +
# mv libz.so.1 libz.so.1.old
 +
# ln -s /usr/lib/libz.so.1 .
  
The modules can then be registered:
+
==== vmplayer/vmware fails to start from version 12.5.3 to version 12.5.5 ====
  
# dkms -m vmware-modules -v 9 -k $(uname -r) add
+
It seems to be a problem with the file {{ic|/usr/lib/vmware/lib/libstdc++.so.6/libstdc++.so.6}}, missing {{ic|CXXABI_1.3.8}}.
  
built:
+
If the system have installed {{pkg|gcc-libs}} or {{pkg|gcc-libs-multilib}}, that library is already installed. Therefore, it's possible to remove that file and vmplayer will use the one provided by gcc-libs instead. As root do:
  
  # dkms -m vmware-modules -v 9 -k $(uname -r) build
+
  # mv /usr/lib/vmware/lib/libstdc++.so.6/libstdc++.so.6 /usr/lib/vmware/lib/libstdc++.so.6/libstdc++.so.6.bak
  
and installed:
+
Also there is a workaround:  
  
  # dkms -m vmware-modules -v 9 -k $(uname -r) install
+
  # export VMWARE_USE_SHIPPED_LIBS='yes'
  
If everything went well, the modules will now be recompiled automatically the next time the kernel changes.
+
==== vmware 12 process terminates immediately after start, no GUI is launched ====
  
== Troubleshooting ==
+
Registered bug at [https://bugs.mageia.org/show_bug.cgi?id=9739 Mageia], but it seems that there are no error messages shown in terminal with arch. When inspecting the logs, which are in {{ic|/tmp/vmware-<id>}}, there are {{ic|VMWARE_SHIPPED_LIBS_LIST is not set}}, {{ic|VMWARE_SYSTEM_LIBS_LIST is not set}}, {{ic|VMWARE_USE_SHIPPED_LIBS is not set}}, {{ic|VMWARE_USE_SYSTEM_LIBS is not set}} issues. Process simply terminates with {{ic|Unable to execute /usr/lib/vmware/bin/vmware-modconfig.}} after vmware or vmplayer is executed. Solution is the same, as root do:
  
=== Could not open /dev/vmmon: No such file or directory. ===
+
# mv /etc/vmware/icu/icudt44l.dat /etc/vmware/icu/icudt44l.dat.bak
  
The full error is:
+
Also there is a workaround:  
Could not open /dev/vmmon: No such file or directory.
 
Please make sure that the kernel module `vmmon' is loaded.
 
  
This means that at least the {{Ic|vmmon}} VMware service is not running. If using the [[systemd]] service from [[#Systemd_service|step 8.]] it should be restarted.
+
# export VMWARE_USE_SHIPPED_LIBS='yes'
  
=== Kernel headers for version 3.x-xxxx were not found. If you installed them[...] ===
+
If it happens on '''12.5.7''' and moving {{ic|icudt44l.dat}} or setting {{ic|VMWARE_USE_SHIPPED_LIBS}} to {{ic|yes}} has no effect or if executing {{ic|vmplayer}} on terminal shows no message, try as root:
  
Install the headers ({{Pkg|linux-headers}}).
+
# cd /usr/lib/vmware/lib/libz.so.1
 +
# mv libz.so.1 libz.so.1.old
 +
# ln -s /usr/lib/libz.so.1 .
  
{{Note|Upgrading the kernel and the headers will require you to boot to the new kernel to match the version of the headers. This is a relatively common error.}}
+
Despite setting the VMWARE_USE_SHIPPED_LIBS variable, VMWare may still fail to find certain libraries. An example is the libfontconfig.so.1 library. Check vmware logs in the tmp directory to see which libraries are still not found. Copy them to the appropriate path with libraries existing on the system:
  
=== USB devices not recognized ===
+
# cp /usr/lib/libfontconfig.so.1 /usr/lib/vmware/lib/libfontconfig.so.1/
  
{{Tip|Also handled by {{AUR|vmware-patch}}.}}
+
Instead of copying all these files manually, you may want to try exporting an additional setting:
  
For some reason, some installations are missing the {{ic|vmware-USBArbitrator}} script. To readd it manually see [https://bbs.archlinux.org/viewtopic.php?pid=1003117#p1003117 this forum post].
+
# export VMWARE_USE_SYSTEM_LIBS='yes'
  
You may also manually extract the VMware bundle and copy the {{ic|vmware-USBArbitrator}} script from {{ic|''destination folder''/vmware-usbarbitrator/etc/init.d/}} to {{ic|/etc/init.d/}}:
+
=== Guest Issues ===
$ ./VMware-''edition''-''version''.''release''.''architecture''.bundle --extract /tmp/vmware-bundle
 
# cp /tmp/vmware-bundle/vmware-usbarbitrator/etc/init.d/vmware-USBArbitrator /etc/init.d/
 
  
=== The installer fails to start ===
+
==== Unable to download VMware Tools for Guests ====
  
If you just get back to the prompt when opening the {{ic|.bundle}}, then you probably have a deprecated or broken version of the VMware installer and you should remove it (you may also refer to the [[#Uninstallation|uninstallation]] section of this article):
+
To download the tools manually, visit the [http://softwareupdate.vmware.com/cds/vmw-desktop/ VMware repository].
# rm -r /etc/vmware-installer
 
  
=== Incorrect login/password when trying to access VMware remotely ===
+
Navigate to: "''application name'' / ''version'' / ''build ID'' / linux / packages/" and download the appropriate Tools.
  
VMware Workstation 10 provides the possibility to remotely manage Shared VMs through the {{ic|vmware-workstation-server}} service. However, this will fail with the error {{ic|"incorrect username/password"}} due to incorrect PAM configuration of the {{ic|vmware-authd}} service. To fix it, edit {{ic|/etc/pam.d/vmware-authd}} like this:
+
Extract with:
  
{{hc|/etc/pam.d/vmware-authd|
+
$ tar -xvf vmware-tools-''name''-''version''-''buildID''.x86_64.component.tar
#%PAM-1.0
 
auth    ''required      pam_unix.so''
 
account  ''required      pam_unix.so''
 
password ''required      pam_permit.so''
 
session  ''required      pam_unix.so''
 
}}
 
  
and restart the {{ic|vmware}} [[systemd]] service.
+
And install using the VMware installer:
  
Now you can connect to the server with the credentials provided during the installation.
+
# vmware-installer --install-component=''/path/''vmware-tools-''name''-''version''-''buildID''.x86_64.component
  
{{Note|{{Pkg|libxslt}} may be required for starting virtual machines.}}
+
If the above does not work, try installing {{AUR|ncurses5-compat-libs}}.
  
=== Issues with ALSA output ===
+
==== Guests have incorrect system clocks or are unable to boot: "[...]timeTracker_user.c:234 bugNr=148722" ====
  
The following instructions from [http://bankimbhavsar.blogspot.co.nz/2011/09/hd-audio-in-vmware-fusion-4-and-vmware.html Bankim Bhavsar's wiki] show how to manually adjust the [[ALSA]] output device in a VMware {{ic|.vmx}} file. This might help with quality issues or with enabling proper HD audio output:
+
This is due to [http://kb.vmware.com/selfservice/microsites/search.do?cmd=displayKC&externalId=1591 incomplete] support of power management features ([[Wikipedia:Intel speedstep|Intel SpeedStep]] and [[Wikipedia:AMD powernow|AMD PowerNow!]]/[[Wikipedia:Cool'n'Quiet|Cool'n'Quiet]]) in VMware Linux that vary the CPU frequency. In March 2012, with the release of [https://projects.archlinux.org/svntogit/packages.git/commit/trunk/config.x86_64?h=packages/linux&id=9abe018d91a5d8c3af7523d30b8aa73f86b680be linux 3.3-1] the maximum frequency [[CPU frequency governors|Performance]] governor was replaced with the dynamic ''Ondemand''. When the host CPU frequency changes, the Guest system clock runs too quickly or too slowly, but may also render the whole Guest unbootable.
  
# Suspend/Power off the VM.
+
To prevent this, the maximum host CPU frequency can be specified, and [[Wikipedia:Time Stamp Counter|Time Stamp Counter]] (TSC) disabled, in the global configuration:
# Run {{ic|aplay -L}}
 
# If you are interested in playing 5.1 surround sound from the guest, look for {{ic|1=surround51:CARD=vendor-name,DEV=num}}. If you are experiencing quality issues, look out for a line starting with front.
 
# Open the {{ic|''Virtual machine name''.vmx}} config file of the VM in a text editor, located under {{ic|~/vmware/''Virtual machine name''/}}, and edit the {{ic|sound.fileName}} field, e.g.: {{ic|1=sound.fileName="surround51:CARD=Live,DEV=0"}}. Ensure that it also reads {{ic|1=sound.autodetect="FALSE"}}.
 
# Resume/Power on the VM.
 
  
=== Kernel-based Virtual Machine (KVM) is running ===
+
{{hc|/etc/vmware/config|2=
To disable {{ic|KVM}} on boot, you can use something like:
+
host.cpukHz = "X"  # The maximum speed in KHz, e.g. 3GHz is "3000000".
       
+
host.noTSC = "TRUE" # Keep the Guest system clock accurate even when
{{hc|/etc/modprobe.d/vmware.conf|
+
ptsc.noTSC = "TRUE" # the time stamp counter (TSC) is slow.
blacklist kvm
 
blacklist kvm-amd  # For AMD CPUs
 
blacklist kvm-intel # For Intel CPUs
 
 
}}
 
}}
 +
 +
{{Tip|To periodically correct the time (once per minute), in the ''Options'' tab of VMware Tools, enable: ''"Time synchronization between the virtual machine and the host operating system"''.}}
 +
 +
==== Networking on Guests not available after system restart ====
 +
 +
This is likely due to the {{ic|vmnet}} module not being loaded [http://www.linuxquestions.org/questions/slackware-14/could-not-connect-ethernet0-to-virtual-network-dev-vmnet8-796095/]. See also the [[#systemd services]] section for automatic loading.
  
 
== Uninstallation ==
 
== Uninstallation ==
Line 288: Line 432:
 
  $ vmware-installer -l
 
  $ vmware-installer -l
  
and uninstall with:
+
and uninstall with ({{ic|--required}}&nbsp;skips the confirmation):
  # vmware-installer -u ''vmware-product''
+
  # vmware-installer -u ''product'' --required
 +
 
 +
{{Tip|Use {{ic|--console}} for the console UI.}}
  
Remember to also disable and remove the {{ic|vmware}} service:
+
Remember to also [[disable]] and remove the services:
# systemctl disable vmware
 
 
  # rm /etc/systemd/system/vmware.service
 
  # rm /etc/systemd/system/vmware.service
 +
# rm /etc/systemd/system/vmware-usbarbitrator.service
  
You may also want to have a look at the module directories in {{ic|/usr/lib/modules/''[kernel name]''/misc/}} for any leftovers.
+
You may also want to have a look at the module directories in {{ic|/usr/lib/modules/''kernel_name''/misc/}} for any leftovers, and remove {{ic|/etc/init.d/}} if now empty.

Latest revision as of 17:42, 24 November 2017

This article is about installing VMware in Arch Linux; you may also be interested in VMware/Installing Arch as a guest.

Note:
  • This article is about the latest major VMware versions, meaning VMware Workstation Pro and Player 12.5.
  • For older versions, use the vmware-patchAUR package.

Contents

Installation

Install the correct dependencies:

Download the latest VMware Workstation Pro or Player (or a beta version, if available).

Start the installation:

# sh VMware-edition-version.release.architecture.bundle
Tip: Some useful flags:
  • --eulas-agreed - Skip the EULAs
  • --console - Use the console UI.
  • --custom - Allows changing the install directory to e.g. /usr/local (make sure to update the vmware-usbarbitrator.service paths in #systemd services).
  • -I, --ignore-errors - Ignore fatal errors.
  • --set-setting=vmware-workstation serialNumber XXXXX-XXXXX-XXXXX-XXXXX-XXXXX - Set the serial number during install (good for scripted installs).
  • --required - Only ask mandatory questions (results in silent install when combined with --eulas-agreed and --console).

For the System service scripts directory, use /etc/init.d (the default).

Note: During the installation you will get an error about "No rc*.d style init script directories" being given. This can be safely ignored, since Arch uses systemd.
Tip: To (re)build the modules from terminal later on, use:
# vmware-modconfig --console --install-all

Configuration

Kernel modules

VMware Workstation 12.5 supports kernels up to 4.8 out of the box.

systemd services

(Optional) Instead of using /etc/init.d/vmware (start|stop|status|restart) and /usr/bin/vmware-usbarbitrator directly to manage the services, you may also use .service files (also available in the vmware-systemd-servicesAUR package, and also included in vmware-patchAUR):

/etc/systemd/system/vmware.service
[Unit]
Description=VMware daemon
Requires=vmware-usbarbitrator.service
Before=vmware-usbarbitrator.service
After=network.target

[Service]
ExecStart=/etc/init.d/vmware start
ExecStop=/etc/init.d/vmware stop
PIDFile=/var/lock/subsys/vmware
RemainAfterExit=yes

[Install]
WantedBy=multi-user.target
/etc/systemd/system/vmware-usbarbitrator.service
[Unit]
Description=VMware USB Arbitrator
Requires=vmware.service
After=vmware.service

[Service]
ExecStart=/usr/bin/vmware-usbarbitrator
ExecStop=/usr/bin/vmware-usbarbitrator --kill
RemainAfterExit=yes

[Install]
WantedBy=multi-user.target

Add this service as well, if you want to connect to your VMware Workstation installation from another Workstation Server Console:

/etc/systemd/system/vmware-workstation-server.service
[Unit]
Description=VMware Workstation Server
Requires=vmware.service
After=vmware.service

[Service]
ExecStart=/etc/init.d/vmware-workstation-server start
ExecStop=/etc/init.d/vmware-workstation-server stop
PIDFile=/var/lock/subsys/vmware-workstation-server
RemainAfterExit=yes

[Install]
WantedBy=multi-user.target

After which you can enable them on boot.

Workstation Server service

The vmware-workstation-server.service calls wssc-adminTool in its command chain, despite having been renamed to vmware-wssc-adminTool.

To prevent the service startup, this can be fixed with a symlink:

# ln -s wssc-adminTool /usr/lib/vmware/bin/vmware-wssc-adminTool

Launching the application

To open VMware Workstation Pro:

$ vmware

or Player:

$ vmplayer

Tips and tricks

Entering the Workstation Pro license key

From terminal

# /usr/lib/vmware/bin/vmware-vmx-debug --new-sn XXXXX-XXXXX-XXXXX-XXXXX-XXXXX

Where XXXXX-XXXXX-XXXXX-XXXXX-XXXXX is your license key.

Note: The -debug binary informs the user of an incorrect license.

From GUI

If the above does not work, you can try:

# /usr/lib/vmware/bin/vmware-enter-serial

Extracting the VMware BIOS

$ objcopy /usr/lib/vmware/bin/vmware-vmx -O binary -j bios440 --set-section-flags bios440=a bios440.rom.Z
$ perl -e 'use Compress::Zlib; my $v; read STDIN, $v, '$(stat -c%s "./bios440.rom.Z")'; $v = uncompress($v); print $v;' < bios440.rom.Z > bios440.rom

Extracting the installer

To view the contents of the installer .bundle:

$ sh VMware-edition-version.release.architecture.bundle --extract /tmp/vmware-bundle/

Using the modified BIOS

If and when you decide to modify the extracted BIOS you can make your virtual machine use it by moving it to ~/vmware/Virtual_machine_name:

$ mv bios440.rom ~/vmware/Virtual_machine_name/

then adding the name to the Virtual_machine_name.vmx file:

~/vmware/Virtual_machine_name/Virtual_machine_name.vmx
bios440.filename = "bios440.rom"

Enable 3D graphics on Intel and Optimus

Some graphics drivers are blacklisted by default, due to poor and/or unstable 3D acceleration. After enabling Accelerate 3D graphics, the log may show something like:

Disabling 3D on this host due to presence of Mesa DRI driver.  Set mks.gl.allowBlacklistedDrivers = TRUE to override.

This means the following:

~/.vmware/preferences
mks.gl.allowBlacklistedDrivers = TRUE

Troubleshooting

Kernel headers for version 4.x-xxxx were not found. If you installed them[...]

Install the headers (linux-headers).

Note: Upgrading the kernel and the headers will require you to boot to the new kernel to match the version of the headers. This is a relatively common error.

USB devices not recognized

Tip: Also handled by vmware-patchAUR.

If not using the systemd service to automatically handle the services, you need to manually start the vmware-usbarbitrator binary as root each time.

To start:

# vmware-usbarbitrator

To stop:

# vmware-usbarbitrator --kill

Incorrect login/password when trying to access VMware remotely

VMware Workstation provides the possibility to remotely manage Shared VMs through the vmware-workstation-server service. However, this will fail with the error "incorrect username/password" due to incorrect PAM configuration of the vmware-authd service. To fix it, edit /etc/pam.d/vmware-authd like this:

/etc/pam.d/vmware-authd
#%PAM-1.0
auth     required       pam_unix.so
account  required       pam_unix.so
password required       pam_permit.so
session  required       pam_unix.so

and restart the vmware systemd service.

Now you can connect to the server with the credentials provided during the installation.

Note: libxslt may be required for starting virtual machines.

Issues with ALSA output

To fix sound quality issues or enabling proper HD audio output, first run:

$ aplay -L

If interested in playing 5.1 surround sound from the guest, look for surround51:CARD=vendor_name,DEV=num, if experiencing quality issues, look for front:CARD=vendor_name,DEV=num. Finally put the name in the .vmx:

~/vmware/Virtual_machine_name/Virtual_machine_name.vmx
sound.fileName="surround51:CARD=Live,DEV=0"
sound.autodetect="FALSE"

OSS emulation should also be disabled.

Kernel-based Virtual Machine (KVM) is running

To disable KVM on boot, you can use something like:

/etc/modprobe.d/vmware.conf
blacklist kvm
blacklist kvm-amd   # For AMD CPUs
blacklist kvm-intel # For Intel CPUs

Module Issues

/dev/vmmon not found

The full error is:

Could not open /dev/vmmon: No such file or directory.
Please make sure that the kernel module 'vmmon' is loaded.

This means that at least the vmmon module is not loaded. See the #systemd services section for automatic loading.

/dev/vmci not found

The full error is:

Failed to open device "/dev/vmci": No such file or directory
Please make sure that the kernel module 'vmci' is loaded.

Try to recompile VMware kernel modules with:

# vmware-modconfig --console --install-all

Kernel modules fail to build after Linux 4.9

On VMware Workstation Pro 12.5.2, the module source needs to be modified to be successfully compiled under kernel 4.9 [1].

# cd /usr/lib/vmware/modules/source
# tar xf vmmon.tar
# mv vmmon.tar vmmon.old.tar
# sed -i 's/uvAddr, numPages, 0, 0/uvAddr, numPages, 0/g' vmmon-only/linux/hostif.c
# tar cf vmmon.tar vmmon-only
# rm -r vmmon-only
# tar xf vmnet.tar
# mv vmnet.tar vmnet.old.tar
# sed -i 's/addr, 1, 1, 0/addr, 1, 0/g' vmnet-only/userif.c
# tar cf vmnet.tar vmnet-only
# rm -r vmnet-only

vmware modules fail to build on kernel 4.11+ and GCC 7

Running vmware-modconfig yields:

Failed to get gcc information.

The actual error can be found in the logs:

modconfig| I125: Got gcc version "6.3.1".
modconfig| I125: GCC major version 6 does not match Kernel GCC major version 7.
modconfig| I125: The GCC compiler "/sbin/gcc" cannot be used for the target kernel.

To skip the check, use this workaround:

# sed 's/gcc version 6/gcc version 7/' /proc/version > /tmp/version
# mount --bind /tmp/version /proc/version
# vmware-modconfig --console --install-all
# umount /proc/version && rm /tmp/version

Kernel modules fail to build on Linux 4.13

On VMware Workstation Pro 12.5.7, the module source needs to be modified to be successfully compiled under kernel 4.13 [2].

# cd /usr/lib/vmware/modules/source
# tar xf vmnet.tar
# mv vmnet.tar vmnet.old.tar
# sed -i 's/atomic_inc(&clone->users);/clone = skb_get(clone);/g' vmnet-only/bridge.c
# tar cf vmnet.tar vmnet-only
# rm -r vmnet-only

Failed to lock page for guest RAM on Linux 4.13

VMware Workstation Pro versions from 12.5 up to 14.0 can lock up both guest and host systems while running a virtual machine under kernel 4.13 without a patch to the vmmon module due to the virtual machine being unable to reserve memory on the host machine. The VM-specific log files show the following errors:

I125: [msg.monitorInit.mem.lockFailed] The virtual machine is unable to reserve memory.
...
E105: PANIC: Failed to lock page for guest RAM!

A collection of patches needed for the VMware host modules to build against recent kernels can be found from the following GitHub repository, vmware-host-modules.

Installer Fails to Start

If you just get back to the prompt when opening the .bundle, then you probably have a deprecated or broken version of the VMware installer and it should removed (you may also refer to the uninstallation section of this article):

# rm -r /etc/vmware-installer/

User interface initialization failed

You may also see an error like this:

 Extracting VMware Installer...done.
 No protocol specified
 No protocol specified
 User interface initialization failed.  Exiting.  Check the log for details.

This can be fixed by either installing the ncurses5-compat-libsAUR dependency or temporarily allowing root access to X:

 $ xhost +
 $ sudo ./<vmware filename>.bundle
 $ xhost -

VMware Fails to Start

Segmentation fault at startup due to old Intel microcode

Old Intel microcode may result in the following kind of segmentation fault at startup:

/usr/bin/vmware: line 31: 4941 Segmentation fault "$BINDIR"/vmware-modconfig --appname="VMware Workstation" --icon="vmware-workstation"

See Microcode for how to update the microcode.

vmplayer/vmware fails to start from version 12.5.4

As per [3] the temporary workaround is to downgrade the package libpng to version 1.6.28-1 and keep it in the IgnorePkg parameter in /etc/pacman.conf.

An easier workaround is to make VMWare use the system's version of zlib instead of its own one:

# cd /usr/lib/vmware/lib/libz.so.1
# mv libz.so.1 libz.so.1.old
# ln -s /usr/lib/libz.so.1 .

vmplayer/vmware fails to start from version 12.5.3 to version 12.5.5

It seems to be a problem with the file /usr/lib/vmware/lib/libstdc++.so.6/libstdc++.so.6, missing CXXABI_1.3.8.

If the system have installed gcc-libs or gcc-libs-multilib, that library is already installed. Therefore, it's possible to remove that file and vmplayer will use the one provided by gcc-libs instead. As root do:

# mv /usr/lib/vmware/lib/libstdc++.so.6/libstdc++.so.6 /usr/lib/vmware/lib/libstdc++.so.6/libstdc++.so.6.bak

Also there is a workaround:

# export VMWARE_USE_SHIPPED_LIBS='yes'

vmware 12 process terminates immediately after start, no GUI is launched

Registered bug at Mageia, but it seems that there are no error messages shown in terminal with arch. When inspecting the logs, which are in /tmp/vmware-<id>, there are VMWARE_SHIPPED_LIBS_LIST is not set, VMWARE_SYSTEM_LIBS_LIST is not set, VMWARE_USE_SHIPPED_LIBS is not set, VMWARE_USE_SYSTEM_LIBS is not set issues. Process simply terminates with Unable to execute /usr/lib/vmware/bin/vmware-modconfig. after vmware or vmplayer is executed. Solution is the same, as root do:

# mv /etc/vmware/icu/icudt44l.dat /etc/vmware/icu/icudt44l.dat.bak

Also there is a workaround:

# export VMWARE_USE_SHIPPED_LIBS='yes'

If it happens on 12.5.7 and moving icudt44l.dat or setting VMWARE_USE_SHIPPED_LIBS to yes has no effect or if executing vmplayer on terminal shows no message, try as root:

# cd /usr/lib/vmware/lib/libz.so.1
# mv libz.so.1 libz.so.1.old
# ln -s /usr/lib/libz.so.1 .

Despite setting the VMWARE_USE_SHIPPED_LIBS variable, VMWare may still fail to find certain libraries. An example is the libfontconfig.so.1 library. Check vmware logs in the tmp directory to see which libraries are still not found. Copy them to the appropriate path with libraries existing on the system:

# cp /usr/lib/libfontconfig.so.1 /usr/lib/vmware/lib/libfontconfig.so.1/

Instead of copying all these files manually, you may want to try exporting an additional setting:

# export VMWARE_USE_SYSTEM_LIBS='yes'

Guest Issues

Unable to download VMware Tools for Guests

To download the tools manually, visit the VMware repository.

Navigate to: "application name / version / build ID / linux / packages/" and download the appropriate Tools.

Extract with:

$ tar -xvf vmware-tools-name-version-buildID.x86_64.component.tar

And install using the VMware installer:

# vmware-installer --install-component=/path/vmware-tools-name-version-buildID.x86_64.component

If the above does not work, try installing ncurses5-compat-libsAUR.

Guests have incorrect system clocks or are unable to boot: "[...]timeTracker_user.c:234 bugNr=148722"

This is due to incomplete support of power management features (Intel SpeedStep and AMD PowerNow!/Cool'n'Quiet) in VMware Linux that vary the CPU frequency. In March 2012, with the release of linux 3.3-1 the maximum frequency Performance governor was replaced with the dynamic Ondemand. When the host CPU frequency changes, the Guest system clock runs too quickly or too slowly, but may also render the whole Guest unbootable.

To prevent this, the maximum host CPU frequency can be specified, and Time Stamp Counter (TSC) disabled, in the global configuration:

/etc/vmware/config
host.cpukHz = "X"  # The maximum speed in KHz, e.g. 3GHz is "3000000".
host.noTSC = "TRUE" # Keep the Guest system clock accurate even when
ptsc.noTSC = "TRUE" # the time stamp counter (TSC) is slow.
Tip: To periodically correct the time (once per minute), in the Options tab of VMware Tools, enable: "Time synchronization between the virtual machine and the host operating system".

Networking on Guests not available after system restart

This is likely due to the vmnet module not being loaded [4]. See also the #systemd services section for automatic loading.

Uninstallation

To uninstall VMware you need the product name (either vmware-workstation or vmware-player). To list all the installed products:

$ vmware-installer -l

and uninstall with (--required skips the confirmation):

# vmware-installer -u product --required
Tip: Use --console for the console UI.

Remember to also disable and remove the services:

# rm /etc/systemd/system/vmware.service
# rm /etc/systemd/system/vmware-usbarbitrator.service

You may also want to have a look at the module directories in /usr/lib/modules/kernel_name/misc/ for any leftovers, and remove /etc/init.d/ if now empty.